<?php
/****************************************************************************
MIDI CLASS CODE
****************************************************************************/

require('./t2mf/classes/midi_duration.class.php');
$file='t2mf/sample_files/beethoven2.mid';

if($_GET['file']) $file='t2mf/sample_files/'.$_GET['file'];
$midi = new MidiDuration();
//$midi->playMidFile('./t2mf/tmp'.$t.'/'.$r.'.mid',true,true,true);
$midi->importMid($file);
//Donnes MIDI
$tc = $midi->getTrackCount();
$base=$midi->getTimebase();
$bpm=round(60000000/$midi->getTempo(),1);
$t=split(chr(10),$midi->getTxt(0));
//Donnes gnriques
$instruments = $midi->getInstrumentList();
$drumset     = $midi->getDrumset();
$drumkit     = $midi->getDrumkitList();
$notes       = $midi->getNoteList();
$colors[]="#F00";
$colors[]="#F80";
$colors[]="#FF0";
$colors[]="#8F0";
$colors[]="#0F0";
$colors[]="#0F8";
$colors[]="#0FF";
$colors[]="#08F";
$colors[]="#00F";
$colors[]="#80F";
$colors[]="#F0F";
$colors[]="#F08";
$colors[]="#444";
$colors[]="#888";
$colors[]="#CCC";
$colors[]="#FFF";
?>
<html>
<head>
<title>Online MIDI sequencer</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
<meta name="mobileoptimized" content="480" />
<meta name="HandheldFriendly" content="true" />
<meta name="viewport" content="width=device-width, height=device-height, initial-scale=1, maximum-scale=1, user-scalable=0"/>
</head>
<style>
div{
	position:absolute;
/*	border:2px 	inset grey;
	margin-left:-2px;*/
	scrollbar-face-color: orange;
    scrollbar-shadow-color: grey;
    scrollbar-highlight-color: grey;
    scrollbar-3dlight-color: darkgrey;
    scrollbar-darkshadow-color: #000000;
    scrollbar-track-color: black;
    scrollbar-arrow-color: #eee8aa;
    font-size:9pt;
    border:1px solid grey;
}
body{
	margin:0;
	padding:0;
	width:100%;
	height:100%;
	background-color:black;
	font-family:Verdana, Tahoma, Arial;
	color:white;
	width:100%;
	height:100%;
	overflow: hidden;
}
#seq{
	width:100%;
	height:100%;
	background-color:black;
	/*background-image:url('http://www.arbrepecheur.com/img/uploads/ckfinder/images/Brushed%20Metal%20(2).jpg');*/
	background-position:center center;
	/*border:10px outset orange;*/
	margin-left:auto;
	margin-right:auto;
}
#menu{
	width:100%;
	height:10%;
	top:0;
	left:0;
	background-color:rgba(0,0,0,0.5);
}
#play{
	width:100%;
	top:12%;
	height:3%;
	position:absolute;
}
#editor
{
	width:100%;
	height:85%;
	top:15%;
	left:0;
}
#piano
{
	width:50px;
	height:100%;
	overflow:hidden;
}
#notes
{
	width:100%;
	height:100%;
	padding-right:16px;
	overflow-x:auto;
	overflow-y:hidden;
	border:none;
}
#fond
{
	width:70%;
	height:100%;
	left:50px;
	overflow-y:auto;
	overflow-x:hidden;
}
#tracks
{
	width:170px;
	height:100%;
	right:0;
	overflow-x:hidden;
	overflow-y:auto;
}
.noir{
	width:50%;
	right:0;
	height:25px;
	background-color:black;
	z-index:1;
}
.blanc{
	width:100%;
	height:35px;
	background-color:white;
	color:black;
}
.track{
	width:100%;
	left:0;
	height:50px;
	padding:2px;
	color:black;
}
.notes{
	width:100%;
	height:<?php echo (1785/87) ?>px;
	border:1px solid grey;
}
.unenote{
	font-size:8px;
	z-index:1;
	cursor:pointer;
	height:<?php echo (1785/87) ?>px;
	margin-top:-1px;
	border:none;
}
select{width:90%;}
#pointeur{
	background-image:url('http://upload.wikimedia.org/wikipedia/commons/thumb/3/3c/Black_triangle.svg/50px-Black_triangle.svg.png');
	background-position:-25px 0;
	background-repeat:no-repeat;
	height:95%;
	width:50px;
	border:none;
	border-left:2px solid red;
	z-index:2;
	left:0;
	position:relative;
}
a{color:white};
</style>
<script type="text/javascript" src="js/a_jquery-1.6.2.min.js"></script>
<script type="text/javascript" src="js/jquery.wipetouch.js"></script>
<script type="text/javascript">
//iW=getInnerWidth();
//iH=getInnerHeight();
var viewportwidth;
var viewportheight;

function getSize()
{
 // the more standards compliant browsers (mozilla/netscape/opera/IE7) use window.innerWidth and window.innerHeight

 if (typeof window.innerWidth != 'undefined')
 {
	  viewportwidth = window.innerWidth,
	  viewportheight = window.innerHeight
 }
// IE6 in standards compliant mode (i.e. with a valid doctype as the first line in the document)
 else if (typeof document.documentElement != 'undefined'
	 && typeof document.documentElement.clientWidth !=
	 'undefined' && document.documentElement.clientWidth != 0)
 {
	   viewportwidth = document.documentElement.clientWidth,
	   viewportheight = document.documentElement.clientHeight
 }
 // older versions of IE
 else
 {
	   viewportwidth = document.getElementsByTagName('body')[0].clientWidth,
	   viewportheight = document.getElementsByTagName('body')[0].clientHeight
 }
}

function play()
{
	//http://www.position-absolute.com/articles/introduction-to-the-html5-audio-tag-javascript-manipulation/

	if($('#notes').is(':animated')) return;

	$('#play').html('<embed id="player" src="<?php echo $file ?>" hidden="false" border="0" width="100%" height="16" autostart="true" autoplay="true" loop="false" volume="75%"/>');
	//var audioElement = document.getElementById('play');
	//audioElement.setAttribute('src', '<?php echo $file ?>');
	//audioElement.load()
	//audioElement.addEventListener("load", function() {
		w=parseInt($('div.unenote:last').css('left'))+parseInt($('div.unenote:last').width())-parseInt($('#notes').width());

		$('#notes').scrollLeft(0);

		$('#pointeur').css('left',0);
		//var xxx=setInterval(checkColorAtPos,100);
		var xxx=0;
		//$('#pointeur').animate({left:w+$('#notes').width()},<?php echo $midi->getDuration()*1000 ?>,'linear');

		$('#notes').animate({'scrollLeft':w+'px'},<?php echo $midi->getDuration()*1000 ?>,'linear',function() { clearInterval(xxx); });
		//audioElement.play();
	//}, true);
}

function stop()
{

	$('#pointeur').stop();

	$('#notes').stop();
	document.getElementById('player').stop();
}

function MuteTrack()
{

	if($('.solo:checked').length==0)
	{

		for(i=0;i<<?php echo count($colors) ?>;i++)
		{

			if($('#mute'+i).is(':checked'))

				$('.piste'+i).css('opacity',0.3);
			else

				$('.piste'+i).css('opacity',1);		
		}
		return;
	}

	for(i=0;i<<?php echo count($colors) ?>;i++)
	{

		if(!$('#solo'+i).is(':checked'))

			$('.piste'+i).css('opacity',0.3);
		else

			$('.piste'+i).css('opacity',1);		
	}
}

$(function() {

	$('#fond').trigger('scroll');

	$(window).trigger('resize');

	$('#notes').scroll(function(){
		var w=parseInt($('div.unenote:last').css('left'))+parseInt($('div.unenote:last').width())-parseInt($('#notes').width());
		var nW=parseInt($('#notes').width());
		var sl=$('#notes').scrollLeft();

		$('#pointeur').css('left',(nW*sl/w)+'px');
	});

	$('#fond').scroll(function(){

		$('#piano').scrollTop($('#fond').scrollTop());

		$('#notes').scrollTop($('#fond').scrollTop());

		$('#notes').css('top',$('#fond').scrollTop());

		$('#pointeur').css('top',$('#fond').scrollTop());
	});

	$('#notes').wipetouch({
	  tapToClick: true, // if user taps the screen, triggers a click event
	  wipeLeft: function(result) { 	

		$('#notes').animate({'scrollLeft':'+=100px'},500);
	  },
	  wipeRight: function(result) {

		$('#notes').animate({'scrollLeft':'-=100px'},500);
	  },
	  wipeUp: function(result) {

		$('#fond').animate({'scrollTop':'+=100px'},500);
	  },
	  wipeDown: function(result) {

		$('#fond').animate({'scrollTop':'-=100px'},500);
	  }
	});

	$(window).resize(function(){
		getSize();

		$('#fond').css('width',(viewportwidth-222));

		$('#fond').trigger('scroll');
	});

	$(window).load(function(){ $('#fond').trigger('scroll'); });
});
</script>
<body>
<div id="seq">
	<div id="menu">
		<?php
		echo $file.'<br/>'.$bpm.' BPM / '.$tc.' track(s) / time base: '.$base.'<br/>'.$t[2];
		?>
		<a href="#" onclick="play()">Jouer</a> - <a href="#" onclick="stop()">Stopper</a>
	</div>
	<div id="play"></div>
	<div id="editor">
		<div id="piano">
		<?php
		$topB=-35;
		$topN=0;
		$top=0;

		for($i=100;$i>=0;$i--)
		{
			$style="noir";

			switch($i%12)
			{

				case "0":

				case "2":

				case "4":

				case "5":

				case "7":

				case "9":

				case "11":
					$style="blanc";
					$topB+=35;
					$top=$topB;
					break;

				default:
					$topN=$topB+25;
					$top=$topN;
			}
			?>
			<div id="note<?php echo $i ?>" class="<?php echo $style ?>" style="top:<?php echo $top ?>px">
			<?php echo str_replace('s','#',$notes[$i]); ?>
			</div>
			<?php
		}
		?>
		</div>
		<div id="fond">
			<div id="pointeur">&nbsp;</div>
			<?php
			$h=(1785/87);
			$top=-$h;

			for($i=100;$i>=0;$i--)
			{
				$style="darkgrey";

				switch($i%12)
				{

					case "0":

					case "2":

					case "4":

					case "5":

					case "7":

					case "9":

					case "11":
						$style="lightgrey";
						break;
				}
				$top+=$h;
				?>
				<div id="notes<?php echo $i ?>" class="notes" style="background-color:<?php echo $style ?>;top:<?php echo $top ?>px">
				&nbsp;
				</div>
				<?php
			}
			?>
			<div id="notes">
				<div id="max" style="top:<?php echo $top ?>px;right:0;"></div>
			<?php
			// Ecriture des notes du fichier MIDI
			$notes=array();
			$tracks=null;

			for($i=0;$i<$tc;$i++)
			{
				$mc=$midi->getMsgCount($i);
				{

					for($j=0;$j<$mc;$j++)
					{
						$msgStr = $midi->getMsg($i, $j);
						$t=split(' ',$msgStr);

						switch($t[1])
						{

							case "Meta":

								if($t[2]=='TrkName')
									$tracks[]=trim(str_replace('"','',$t[3]));
								break;

							case "TimeSig":
								break;

							case "KeySig":
								break;

							case "Tempo":
								break;

							case "On":
								$l=$t[0]/5;
								$ch=substr($t[2],3);
								$n=substr($t[3],2);
								$v=substr($t[4],2);

								if(!isset($notes[$ch])) $notes[$ch]=array();

								if($v=='0')
								{
									$notes[$ch][count($notes[$ch])-1]['end']=$l;
								}
								else
								{							
									$note['start']=$l;
									$note['nbr']=$n;
									$note['vol']=$v;
									$notes[$ch][count($notes[$ch])]=$note;
								}
								break;

							case "Off":
								$l=$t[0]/5;
								$notes[$ch][count($notes[$ch])-1]['end']=$l;							
								break;

							case "Par":
								break;
						}
					}
				}
			}
			//print_r($notes);
			$j=0;

			foreach($notes as $ch=>$tNotes)
			{

				for($i=0;$i<count($tNotes);$i++)
				{
					$len=$tNotes[$i]['end']-$tNotes[$i]['start'];
					$l=$tNotes[$i]['start'];
					$v=$tNotes[$i]['vol'];
					$n=100-$tNotes[$i]['nbr'];
					?>
					<div title="Piste <?php echo ($j+1) ?>" class="unenote piste<?php echo $j ?>" style="background-color:<?php echo setRgba($colors[$j],$v) ?>;background-color:<?php echo $colors[$j] ?>;top:<?php echo $h*$n ?>px;left:<?php echo $l ?>px;width:<?php echo $len ?>px">&nbsp;</div>
					<?php
				}
				$j++;
			}
			?>
			</div>
		</div>
		<div id="tracks">
		<?php
		$top=0;

		for($i=0;$i<count($colors);$i++)
		{
			?>
			<div id="track<?php echo $i ?>" class="track" style="background-color:<?php echo $colors[$i] ?>;top:<?php echo $top ?>px">
			Piste <?php echo ($i+1) ?>
			<img src="http://icons.iconarchive.com/icons/famfamfam/silk/16/sound-mute-icon.png"/><input type="checkbox" id="mute<?php echo $i ?>" onclick="MuteTrack();"/>
			<img src="http://icons.iconarchive.com/icons/everaldo/crystal-clear/16/App-kaboodle-headset-icon.png"/><input type="checkbox" class="solo" id="solo<?php echo $i ?>" onclick="MuteTrack();"/>
			<br/>
			<select name="inst<?php echo $k?>">
				<optgroup label="Instruments">
				<?php

					foreach ($instruments as $key=>$val) echo '<option value="'.$key.'"'.(($val==$tracks[$i])?' selected="selected"':'').">$val</option>\n";
				?>
				</optgroup>
				<!-- <optgroup label="Drum sets">
				<?php

					foreach ($drumset as $key=>$val) echo '<option value="'.$key.'"'.(($val==$tracks[$i])?' selected="selected"':'').">$val</option>\n";
				?>
				</optgroup> -->
				<optgroup label="Drum kits">
				<?php

					foreach ($drumkit as $key=>$val) echo '<option value="'.$key.'"'.(($val==$tracks[$i])?' selected="selected"':'').">$val</option>\n";
				?>
				</optgroup>
			</select>
			</div>
			<?php
			$top+=50;
		}
		?>
		</div>
	</div>	
</div>
</body>
</html>
<?php

function setRgba($color='#FFF', $volume=127)
{
	$retour='rgba(';

	for($i=1;$i<=3;$i++)
	{
		$c=hexdec(substr($color,$i,1))*16;

		if($c>255) $c=255;
		$retour.=$c.',';
	}
	$retour.=round($volume/127,2).')';
	return $retour;
}